#include "core/SpinLock.h"

#include <threads.h>

void coreInitSpinLock(CoreSpinLock* l) {
    atomic_init(&l->lock, false);
}

void coreLockSpinLock(CoreSpinLock* l) {
    while(true) {
        bool expected = false;
        if(atomic_compare_exchange_weak(&l->lock, &expected, true)) {
            break;
        }
        struct timespec s = {.tv_nsec = 0, .tv_sec = 0};
        thrd_sleep(&s, nullptr);
    }
}

void coreUnlockSpinLock(CoreSpinLock* l) {
    atomic_store(&l->lock, false);
}
